SystemOrganization addCategory: #DiceHandle!

TestCase subclass: #DiceHandleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceHandle'!

!DiceHandleTest commentStamp: '<historical>' prior: 0!
dice handle test!

!DiceHandleTest methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:23'!
testAddingTwiceTheSameDice
| handle |
handle := DiceHandle new.
handle addDie: (Die faces: 6).
self assert: handle diceNumber = 1.
handle addDie: (Die faces: 6).
self assert: handle diceNumber = 2.
! !

!DiceHandleTest methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:23'!
testCreationAdding
| handle |
handle := DiceHandle new
addDie: (Die faces: 6);
addDie: (Die faces: 10);
yourself.
self assert: handle diceNumber = 2.
! !

!DiceHandleTest methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:30'!
testSimpleHandle
self assert: 2 D20 diceNumber = 2.

! !

!DiceHandleTest methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:33'!
testSumming
| handle |
handle := 2 D20 + 3 D10.
self assert: handle diceNumber = 5.
! !

TestCase subclass: #DieTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceHandle'!

!DieTest methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:18'!
testCreationIsOk
self shouldnt: [ Die faces: 20 ] raise: Error
! !

!DieTest methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:16'!
testInitializeIsOk
self shouldnt: [ Die new ] raise: Error! !

!DieTest methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:18'!
testRolling
| d |
d := Die new.
10 timesRepeat: [ self assert: (d roll between: 1 and: 6) ]! !

!Integer methodsFor: '*DiceHandle' stamp: 'irevoire 1/20/2017 13:32'!
D10
^ self D: 10! !

!Integer methodsFor: '*DiceHandle' stamp: 'irevoire 1/20/2017 13:32'!
D20
^ self D: 20
! !

!Integer methodsFor: '*DiceHandle' stamp: 'irevoire 1/20/2017 13:31'!
D4
^ self D: 4! !

!Integer methodsFor: '*DiceHandle' stamp: 'irevoire 1/20/2017 13:32'!
D6
^ self D: 6! !

!Integer methodsFor: '*DiceHandle' stamp: 'irevoire 1/20/2017 13:31'!
D: anInteger
| handle |
handle := DiceHandle new.
self timesRepeat: [ handle addDie: (Die faces: anInteger)].
^ handle! !

Object subclass: #DiceHandle
	instanceVariableNames: 'dice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceHandle'!

!DiceHandle commentStamp: '<historical>' prior: 0!
a dice handle
!

!DiceHandle methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:56'!
+ aDiceHandle
| handle |
	handle := self class new.
	dice do: [ :each | handle addDie: each ].
	aDiceHandle getDice do: [ :each | handle addDie: each ].
	^ handle! !

!DiceHandle methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:27'!
addDie: aDie
dice add: aDie
! !

!DiceHandle methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:28'!
diceNumber
^ dice size! !

!DiceHandle methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:57'!
getDice
	^ dice! !

!DiceHandle methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:26'!
initialize
super initialize.
dice := OrderedCollection new.
! !

!DiceHandle methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:28'!
roll
| res |
res := 0.
dice do: [ :each | res := res + each roll ].
^ res! !

Object subclass: #Die
	instanceVariableNames: 'faces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DiceHandle'!

!Die commentStamp: '<historical>' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State a one line summary. For example, "I represent a paragraph of text".

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	faces:		<Object>


    Implementation Points!

!Die class methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:20'!
faces: aNumber
^ self new faces: aNumber; yourself! !

!Die methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:21'!
faces: aNumber
	faces := aNumber! !

!Die methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:14'!
initialize
	super initialize.
	faces := 6! !

!Die methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:28'!
printOn: aStream
super printOn: aStream.
aStream nextPutAll: ' (', faces printString, ')'
! !

!Die methodsFor: 'initialization' stamp: 'irevoire 1/20/2017 13:17'!
roll
	^ faces atRandom! !
